Attribute VB_Name = "modStats"
Option Explicit


' Note: If you want to learn more about these functions
'          visit msdn.microsoft.com!



Public Const NO_ERROR = 0


' Time-out algorithms
Public Const MIB_TCP_RTO_OTHER = 1          ' Unknown?
Public Const MIB_TCP_RTO_CONSTANT = 2    ' Constant
Public Const MIB_TCP_RTO_RSRE = 3             ' MIL-STD-1778 Appendix B
Public Const MIB_TCP_RTO_VANJ = 4             ' Van Jacobsons Algorithm



Public Type PMIB_TCPSTATS
    dwRtoAlgorithm As Long
    dwRtoMin As Long
    dwRtoMax As Long
    dwMaxConn As Long
    dwActiveOpens As Long
    dwPassiveOpens As Long
    dwAttemptFails As Long
    dwEstabResets As Long
    dwCurrEstab As Long
    dwInSegs As Long
    dwOutSegs As Long
    dwRetransSegs As Long
    dwInErrs As Long
    dwOutRsts As Long
    dwNumConns As Long
End Type

Public Type PMIB_UDPSTATS
    dwInDatagrams As Long
    dwNoPorts As Long
    dwInErrors As Long
    dwOutDatagrams As Long
    dwNumAddrs As Long
End Type

Public Type MIBICMPSTATS
    dwMsgs As Long
    dwErrors As Long
    dwDestUnreachs As Long
    dwTimeExcds As Long
    dwParmProbs As Long
    dwSrcQuenchs As Long
    dwRedirects As Long
    dwEchos As Long
    dwEchoReps As Long
    dwTimestamps As Long
    dwTimestampReps As Long
    dwAddrMasks As Long
    dwAddrMaskReps As Long
End Type

Type MIBICMPINFO
    icmpInStats As MIBICMPSTATS
    icmpOutStats As MIBICMPSTATS
End Type

Public Type PMIB_IPSTATS
    dwForwarding As Long
    dwDefaultTTL As Long
    dwInReceives As Long
    dwInHdrErrors As Long
    dwInAddrErrors As Long
    dwForwDatagrams As Long
    dwInUnknownProtos As Long
    dwInDiscards As Long
    dwInDelivers As Long
    dwOutRequests As Long
    dwRoutingDiscards As Long
    dwOutDiscards As Long
    dwOutNoRoutes As Long
    dwReasmTimeout As Long
    dwReasmReqds As Long
    dwReasmOks As Long
    dwReasmFails As Long
    dwFragOks As Long
    dwFragFails As Long
    dwFragCreates As Long
    dwNumIf As Long
    dwNumAddr As Long
    dwNumRoutes As Long
End Type


Public Declare Function GetTcpStatistics Lib "iphlpapi" (pStats As PMIB_TCPSTATS) As Long
Public Declare Function GetUdpStatistics Lib "iphlpapi" (pStats As PMIB_UDPSTATS) As Long
Public Declare Function GetIcmpStatistics Lib "iphlpapi" (pStats As MIBICMPINFO) As Long
Public Declare Function GetIpStatistics Lib "iphlpapi" (pStats As PMIB_IPSTATS) As Long
